package gcewing.lighting.ic2;

import net.minecraft.block.material.*;
import net.minecraft.entity.player.*;
import net.minecraft.tileentity.*;
import net.minecraft.world.*;

import gcewing.lighting.*;

public class BlockFloodlightIC2 extends BlockFloodlight  {

	public BlockFloodlightIC2(int id) {
		super(id, 6, Material.rock);
	}

	@Override
	public int getBlockTextureFromSideAndMetadata(int side, int data) {
		int base = blockIndexInTexture;
		if ((data & 1) != 0)
			base += 4;
		switch (side) {
			case 0: return base; // bottom
			case 1: return base + 3; // top
			default: return base + 1 + ((data >> 1) & 1); // sides
		}
	}

	@Override
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player,
		int par6, float par7, float par8, float par9)
	{
		if (!player.isSneaking()) {
			if (!world.isRemote)
				flipSwitch(world, x, y, z);
			return true;
		}
		else
			return false;
	}

	@Override
	public TileEntity createNewTileEntity(World world) {
		return new TEFloodlightIC2();
	}
	
	public void flipSwitch(World world, int x, int y, int z) {
		int data = world.getBlockMetadata(x, y, z);
		world.setBlockMetadata(x, y, z, data ^ 2);
		world.markBlockForUpdate(x, y, z);
		update(world, x, y, z);
	}

	@Override
	public boolean isActive(World world, int x, int y, int z) {
		TEFloodlightIC2 te = (TEFloodlightIC2)world.getBlockTileEntity(x, y, z);
		return te.isActive();
	}

}
