//------------------------------------------------------
//
//   Greg's Lighting - IC2
//
//------------------------------------------------------

package gcewing.lighting.ic2;

import net.minecraft.block.*;
import net.minecraft.creativetab.*;
import net.minecraft.item.*;
import net.minecraft.item.crafting.*;
import cpw.mods.fml.common.registry.*;
import ic2.api.Items;
import gcewing.lighting.*;

public class GregsLightingIC2 {

	public static BlockFloodlight floodlightIC2;
	
	public static ItemStack tinCable, insulatedCopperCable;

	public static void init() {
		try {
			getItems();
		}
		catch (MissingItem e) {
			System.out.printf("GregsLighting: Not all IC2 items available\n");
			return;
		}
		registerBlocks();
		registerItems();
		registerRecipes();
		registerTileEntities();
	}
	
	static void registerBlocks() {
		floodlightIC2 = new BlockFloodlightIC2(GregsLighting.getBlockID(1033, "ic2ElectricFloodlight"));
		floodlightIC2.setHardness(1.5F).setCreativeTab(CreativeTabs.tabMisc);
		GregsLighting.addBlock("IC2 Electric Floodlight", floodlightIC2);
	}
	
	static void registerItems() {
	}

	static void registerRecipes() {
		GregsLighting.addOreRecipe(GregsLighting.ic2Filament, 1, " t ", "t t", "cic",
			't', tinCable, 'i', insulatedCopperCable, 'c', "ingotCopper");
		GregsLighting.addRecipe(GregsLighting.ic2Bulb, 1, "rGr", "GfG",
			'G', Block.glass, 'f', GregsLighting.ic2Filament, 'r', Item.redstone);
		GregsLighting.addRecipe(floodlightIC2, 1, "IrI", "IbI", "GGG",
			'I', Item.ingotIron, 'r', Item.redstone, 'b', GregsLighting.ic2Bulb, 'G', Block.glass);
	}
	
	static void registerTileEntities() {
		GameRegistry.registerTileEntity(TEFloodlightIC2.class, "gcewing.IC2ElectricFloodlight");
	}
	
	static void getItems() throws MissingItem {
		tinCable = ic2Item("tinCableItem");
		insulatedCopperCable = ic2Item("insulatedCopperCableItem");
	}
	
	static ItemStack ic2Item(String name) throws MissingItem {
		ItemStack stack = Items.getItem(name);
		if (stack == null)
			throw new MissingItem();
		return stack;
	}

}

class MissingItem extends Exception {
}

